#ifndef uConfigH
#define uConfigH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <jpeg.hpp>

class TfConfig:public TForm
{
  __published:                  // Composants grs par l'EDI
  TPanel * pMain;
  TPageControl *pcMain;
  TTabSheet *tsGeneral;
  TRadioGroup *rgCsbDevice;
        TRadioGroup *rgStartMode;
  TRadioGroup *rgScanMode;
  TTabSheet *tsOutput;
  TRadioGroup *rgOutputPrefix;
  TRadioGroup *rgOutputPostfix;
  TRadioGroup *rgScanDelay;
  TRadioGroup *rgScanFilter;
  TCheckBox *cbBeep;
  TTabSheet *tsMifare;
  TLabel *lbMifareBlock;
  TLabel *lbMifareOffset;
  TLabel *lbMifareSize;
  TLabel *Label1;
  TEdit *eMifareBlock;
  TUpDown *udMifareBlock;
  TEdit *eMifareOffset;
  TUpDown *udMifareOffset;
  TEdit *eMifareSize;
  TUpDown *udMifareSize;
  TEdit *eMifareKey;
  TRadioGroup *rgMifareFormat;
  TCheckBox *cbMifareRevert;
  TTabSheet *ts14443a;
  TRadioGroup *rg14443aFormat;
  TCheckBox *cb14443aRevert;
  TCheckBox *cb14443aA;
  TCheckBox *cb14443aATQ;
  TCheckBox *cb14443aSAK;
  TRadioGroup *rg14443aSize;
  TTabSheet *ts14443b;
  TRadioGroup *rg14443bSize;
  TRadioGroup *rg14443bFormat;
  TCheckBox *cb14443bRevert;
  TCheckBox *cb14443bB;
  TPanel *pBottom;
  TPanel *pTop;
  TButton *btnOK;
  TButton *btnCancel;
  TGroupBox *gbTest;
  TSpeedButton *btnTest;
  TLabel *lbTestStatus;
  TEdit *eTest;
  TTimer *tmrWork;
  TCheckBox *cbRemoveLeading0;
        TLabel *lbTitle;
        TLabel *lbCaption;
        TImage *imgLogo;
        TImage *Image1;
  void __fastcall btnOKClick(TObject * Sender);
  void __fastcall FormCreate(TObject * Sender);
  void __fastcall FormDestroy(TObject * Sender);
  void __fastcall btnCancelClick(TObject * Sender);
  void __fastcall rgScanModeClick(TObject * Sender);
  void __fastcall rg14443aSizeClick(TObject * Sender);
  void __fastcall rg14443aFormatClick(TObject * Sender);
  void __fastcall rg14443bSizeClick(TObject * Sender);
  void __fastcall rg14443bFormatClick(TObject * Sender);
  void __fastcall SettingsToScreen();
  void __fastcall ScreenToSettings();
  void __fastcall btnTestClick(TObject * Sender);
  void __fastcall tmrWorkTimer(TObject * Sender);
  void __fastcall FormClose(TObject * Sender, TCloseAction & Action);
private:                       // Dclarations de l'utilisateur
  bool CsbActive;
  AnsiString LastScan;
  HANDLE ConfigMutex;
public:                        // Dclarations de l'utilisateur
    __fastcall TfConfig(TComponent * Owner);
};

extern PACKAGE TfConfig *fConfig;

#endif
